<?php

/*
 * This file is part of the Jiannei/lumen-api-starter.
 *
 * (c) Jiannei <longjian.huang@foxmail.com>
 *
 * This source file is subject to the MIT license that is bundled
 * with this source code in the file LICENSE.
 */

namespace App\Providers;

use Illuminate\Filesystem\Filesystem;
use Prettus\Repository\Providers\LumenRepositoryServiceProvider;

class RepositoryServiceProvider extends LumenRepositoryServiceProvider
{

    public function register()
    {
        parent::register(); // TODO: Change the autogenerated stub
        $this->bindRepository();
    }

    protected function bindRepository()
    {
        $fileObj = (new Filesystem());
        $files = $fileObj->files(base_path('app/Repositories/Contracts'));
        if($files){
            collect($files)->map(function ($file){
                $fileName = $file->getRelativePathname();
                list($name,$extend) = explode('.',$fileName);
                $class = "App\Repositories\Contracts\\".$name;
                $concrete = "App\Repositories\Eloquent\\".$name."Eloquent";
                $this->app->bind($class,$concrete);
            });
        }
    }
}
