<?php

namespace App\Support\Traits;

use App\Services\SysLogService;
use App\Support\Facades\SimpleLogs;
use longlang\phpkafka\Consumer\ConsumerConfig;
use longlang\phpkafka\Producer\ProducerConfig;

trait KafkaConfigHelpers
{

    public function getProducerConfig($config)
    {
        $kafkaConfig = app(ProducerConfig::class);
        $kafkaConfig->setBootstrapServer($config['host'].":".$config['port']);
        $kafkaConfig->setUpdateBrokers(true);
        $kafkaConfig->setAcks(-1);

        return $kafkaConfig;
    }

    public function getConsumerConfig($config)
    {
        $kafkaConfig = new ConsumerConfig();
        $kafkaConfig->setBroker([$config['host'].":".$config['port']]);
        $kafkaConfig->setTopic($config['topic']); // 主题名称
        $client_id = uniqid(time(),true);
        $kafkaConfig->setGroupId($config['groupid']); // 分组ID
        SimpleLogs::writeLog('group id is '.$config['groupid'].$client_id, 'kafka_client_id');
        $kafkaConfig->setClientId($client_id); // 客户端ID
        $kafkaConfig->setGroupInstanceId($client_id); // 分组实例ID

        return $kafkaConfig;
    }

}
